import boto3
from boto3.dynamodb.conditions import Attr

dynamodb = boto3.resource('dynamodb')
table = dynamodb.Table('TestCertificates')

def get_cert_authority_column(equal):
    response = []
    if equal:
        response = table.scan(
                FilterExpression=Attr('log_type').eq('PrecertLogEntry') 
                )['Items']
    else:
        response = table.scan(
                FilterExpression=Attr('log_type').ne('PrecertLogEntry')
                )['Items']

    result = []
    for item in response:
        result.append(item['cert_authority'])

    return result

def get_diff(first, second):
    return list(set(first) - set(second))

def print_result(lst, str):
    print(str)
    for elem in lst:
        print(" > ", elem)
    print("Returned ", len(lst), " rows.")

if __name__ == '__main__':
    response_precert = get_cert_authority_column(True)
    response_not_precert = get_cert_authority_column(False)
    response = get_diff(response_not_precert, response_precert)
    print_result(set(response_precert), "Certificate authorities (cert_authority) that use precert:")
    print_result(response, "Certificate authorities (cert_authority) that don't use precert:")

