import csv
import time
import boto3 # https://aws.amazon.com/sdk-for-python/

current_milli_time = lambda: int(round(time.time() * 1000))
dynamodb = boto3.resource('dynamodb')
table = dynamodb.Table('TestCertificates')  # table name here

def add_rows_in_batch(data):
    with table.batch_writer() as batch:
        for item in data:
            batch.put_item(Item = item)


def run_batch_migration():
    start = current_milli_time()
    row_count = 0
    batch = []
    with open("./thousandLinesSample", newline = '') as csvfile:
        reader = csv.reader(csvfile, delimiter = ';')
        for row in reader:
            row_count += 1
            item = {
                #'id': int(row_count),
                'cert_info_link': row[0],
                'not_valid_before': int(row[1]),
                'not_valid_after': int(row[2]),
                'cert_common_name': row[3],
                'cert_authority': row[4],
                'log_type': row[5]
            }
            batch.append(item)
            if row_count % 25 == 0:
                add_rows_in_batch(batch)
                batch = []
        add_rows_in_batch(batch)

    print('Number of rows processed - ', str(row_count))
    end = current_milli_time()
    print('Total time taken for migration : ', str((end - start) / 1000), ' secs')


if __name__ == "__main__":
    run_batch_migration()
    
# https://stackoverflow.com/questions/32678325/how-to-import-bulk-data-from-csv-to-dynamodb
